drop _all
*generate 1000 observations
set obs 1000

*draw a sample from N(10,3^2) of size 100
gen x=rnormal(10,3) if _n<=100

*create a grid of possible mu values from 0 to 20 with step 0.02
gen mu=_n/50

*lden will hold the log likelihood (pdf) contribution of each observation x for a given mu and sigma=3
gen lden=.

*will hold the sum of log likelihood (pdf) contributions from 100 observations for the corresponding mu
gen Slden=.

*repeat for all values of mu
forval i=1(1)1000 {
	*normal den gives the pdf
	qui replace lden=log(normalden(x,mu[`i'],3))
	*first summarize to get the sum which is stored in r(sum)
	qui sum lden
	*replace Slden for given mu (only in line i)
	qui replace Slden=r(sum) if _n==`i'
	
}

*a null glm model for x (identity link, normal distribution is the default)
glm x

*coincides with aritmetic mean
sum x

*graph of log-likelihood vs mu
sc Slden mu

*check which mu value from the grid maximizes log-likelihood 
gsort -Slden
li in 1